# Create Repeating transactions

> Source: https://truto.one/docs/api-reference/unified-accounting-api/repeatingtransactions/create/

`POST /unified/accounting/repeating_transactions`

Resource: **RepeatingTransactions** · API: **Unified Accounting API**

## Supported integrations

QuickBooks, Xero

## Query parameters

- **`integrated_account_id`** _(string, required)_
  The ID of the integrated account to use for the request.
- **`truto_response_format`** _(string)_
  The format of the response. - `unified` returns the response with unified mappings applied. - `raw` returns the unprocessed, raw response from the remote API. - `normalized` applies the unified mappings and returns the data in a normalized format. - `stream` returns the response as a stream, which is ideal for transmitting large datasets, files, or binary data. Using streaming mode helps to efficiently handle large payloads or real-time data flows without requiring the entire data to be buffered in memory. Defaults to `unified`.
  Allowed: `unified`, `raw`, `normalized`, `stream`
- **`truto_ignore_remote_data`** _(boolean)_
  Excludes the `remote_data` attribute from the response.
- **`truto_exclude_fields`** _(array<string>)_
  Array of fields to exclude from the response.
- **`remote_query`** _(object)_
  Query parameters to pass to the underlying API without any transformations. Refer [this guide](https://truto.one/docs/api-reference/overview/querying#remote-query-parameters) to see how to structure the query parameters.

## Request body

- **`name`** _(string)_
  The name of the repeating transaction
- **`entity`** _(object)_
  The entity of the repeating transaction. The schema will be based on the type of entity, but `id` and `type` will always be present.
  - **`id`** _(string, required)_
    The unique identifier for the entity
  - **`type`** _(string, required)_
    The type of the entity
    Allowed: `invoice`, `purchase_order`, `vendor_credit`, `credit_note`, `journal_entry`
- **`status`** _(boolean)_
  The status of the repeating transaction
  Allowed: `active`, `archived`
- **`recurring_type`** _(string)_
  The recurring type of the repeating transaction
  Allowed: `unscheduled`, `automated`, `reminded`
- **`interval_type`** _(string)_
  The interval type of the repeating transaction
  Allowed: `daily`, `weekly`, `monthly`, `yearly`, `monthly`, `weekly`
- **`interval_num`** _(number)_
  The interval number of the repeating transaction. E.g., 1 (every 1 week), 2 (every 2 months), etc.
- **`start_date`** _(string)_
  The start date for the repeating transaction
- **`end_date`** _(string)_
  The end date for the repeating transaction
- **`max_occurrences`** _(number)_
  The maximum number of occurrences for the repeating transaction
- **`days_before`** _(number)_
  The days before of the repeating transaction
- **`day_of_month`** _(number)_
  The day of the month of the repeating transaction
- **`due_date_type`** _(string)_
  Type of due date for repeating transactions
  Allowed: `days_after_bill_date`, `days_after_bill_month`, `of_current_month`, `of_following_month`
- **`contact`** _(unknown)_
- **`line_items`** _(array<object>)_
  The line items of the repeating transaction
  - **`note`** _(string)_
    The note of the line item
  - **`id`** _(string)_
    The unique identifier for the line item
  - **`quantity`** _(number)_
    The quantity for the line item
  - **`account`** _(string)_
    The ID of the account
- **`line_amount_type`** _(string)_
  The type of line amount for repeating transaction
  Allowed: `exclusive`, `inclusive`, `no_tax`
- **`currency`** _(string)_
  The currency of the repeating transaction
- **`remote_data`** _(object)_
  Any additional data that should be passed as part of the request body. This data is not transformed by Truto and is passed as is to the remote API.

## Response body

- **`id`** _(string, required)_
  The unique identifier for repeating transaction
- **`name`** _(string)_
  The name of the repeating transaction
- **`entity`** _(object)_
  The entity of the repeating transaction. The schema will be based on the type of entity, but `id` and `type` will always be present.
  - **`id`** _(string, required)_
    The unique identifier for the entity
  - **`type`** _(string, required)_
    The type of the entity
    Allowed: `invoice`, `purchase_order`, `vendor_credit`, `credit_note`, `journal_entry`
- **`status`** _(boolean)_
  The status of the repeating transaction
  Allowed: `active`, `archived`
- **`recurring_type`** _(string)_
  The recurring type of the repeating transaction
  Allowed: `unscheduled`, `automated`, `reminded`
- **`interval_type`** _(string)_
  The interval type of the repeating transaction
  Allowed: `daily`, `weekly`, `monthly`, `yearly`
- **`interval_num`** _(number)_
  The interval number of the repeating transaction. E.g., 1 (every 1 week), 2 (every 2 months), etc.
- **`day_of_month`** _(number)_
  The day of the month of the repeating transaction
- **`month_of_year`** _(number)_
  The month of the year of the repeating transaction
- **`day_of_week`** _(number)_
  The day of the week of the repeating transaction
- **`week_of_month`** _(number)_
  The week of the month of the repeating transaction
- **`days_before`** _(number)_
  The days before of the repeating transaction
- **`start_date`** _(string)_
  The start date for the repeating transaction
- **`end_date`** _(string)_
  The end date for the repeating transaction
- **`max_occurrences`** _(number)_
  The maximum number of occurrences for the repeating transaction
- **`next_date`** _(string)_
  The next date of the repeating transaction
- **`prev_date`** _(string)_
  The previous date of the repeating transaction
- **`created_at`** _(string)_
  Rhe date when the repeating transaction was created
- **`updated_at`** _(string)_
  The date when the repeating transaction was updated
- **`remote_data`** _(object)_
  Raw data returned from the remote API call.

## Code examples

### curl

```bash
curl -X POST 'https://api.truto.one/unified/accounting/repeating_transactions?integrated_account_id=<integrated_account_id>' \
  -H 'Authorization: Bearer <your_api_token>' \
  -H 'Content-Type: application/json' \
  -d '{
  "name": "your_name",
  "entity": {},
  "status": "active",
  "recurring_type": "unscheduled",
  "interval_type": "daily",
  "interval_num": 0,
  "start_date": "your_start_date",
  "end_date": "your_end_date",
  "max_occurrences": 0,
  "days_before": 0,
  "day_of_month": 0,
  "due_date_type": "days_after_bill_date",
  "line_items": [],
  "line_amount_type": "exclusive",
  "currency": "your_currency",
  "remote_data": {}
}'
```

### JavaScript

```javascript
const integratedAccountId = '<integrated_account_id>';

const body = {
  "name": "your_name",
  "entity": {},
  "status": "active",
  "recurring_type": "unscheduled",
  "interval_type": "daily",
  "interval_num": 0,
  "start_date": "your_start_date",
  "end_date": "your_end_date",
  "max_occurrences": 0,
  "days_before": 0,
  "day_of_month": 0,
  "due_date_type": "days_after_bill_date",
  "line_items": [],
  "line_amount_type": "exclusive",
  "currency": "your_currency",
  "remote_data": {}
};

const response = await fetch(`https://api.truto.one/unified/accounting/repeating_transactions?integrated_account_id=${integratedAccountId}`, {
  method: 'POST',
  headers: {
    'Authorization': 'Bearer <your_api_token>',
    'Content-Type': 'application/json',
  },
  body: JSON.stringify(body),
});

const data = await response.json();
console.log(data);
```

### Python

```python
import requests

url = "https://api.truto.one/unified/accounting/repeating_transactions"
headers = {
    "Authorization": "Bearer <your_api_token>",
    "Content-Type": "application/json",
}
params = {
    "integrated_account_id": "<integrated_account_id>"
}
payload = {
    "name": "your_name",
    "entity": {},
    "status": "active",
    "recurring_type": "unscheduled",
    "interval_type": "daily",
    "interval_num": 0,
    "start_date": "your_start_date",
    "end_date": "your_end_date",
    "max_occurrences": 0,
    "days_before": 0,
    "day_of_month": 0,
    "due_date_type": "days_after_bill_date",
    "line_items": [],
    "line_amount_type": "exclusive",
    "currency": "your_currency",
    "remote_data": {}
}

response = requests.post(url, headers=headers, params=params, json=payload)
print(response.json())
```

### Truto TS SDK

```typescript
import Truto from '@truto/truto-ts-sdk';

const truto = new Truto({
  token: '<your_api_token>',
});

const result = await truto.unifiedApi.create(
  'accounting',
  'repeatingtransactions',
  {
  "name": "your_name",
  "entity": {},
  "status": "active",
  "recurring_type": "unscheduled",
  "interval_type": "daily",
  "interval_num": 0,
  "start_date": "your_start_date",
  "end_date": "your_end_date",
  "max_occurrences": 0,
  "days_before": 0,
  "day_of_month": 0,
  "due_date_type": "days_after_bill_date",
  "line_items": [],
  "line_amount_type": "exclusive",
  "currency": "your_currency",
  "remote_data": {}
},
  { integrated_account_id: '<integrated_account_id>' }
);

console.log(result);
```

### Truto Python SDK

```python
import asyncio
from truto_python_sdk import TrutoApi

truto_api = TrutoApi(token="<your_api_token>")

async def main():
    result = await truto_api.unified_api.create(
        "accounting",
        "repeatingtransactions",
        {
        "name": "your_name",
        "entity": {},
        "status": "active",
        "recurring_type": "unscheduled",
        "interval_type": "daily",
        "interval_num": 0,
        "start_date": "your_start_date",
        "end_date": "your_end_date",
        "max_occurrences": 0,
        "days_before": 0,
        "day_of_month": 0,
        "due_date_type": "days_after_bill_date",
        "line_items": [],
        "line_amount_type": "exclusive",
        "currency": "your_currency",
        "remote_data": {}
},
        {"integrated_account_id": "<integrated_account_id>"}
    )
    print(result)

asyncio.run(main())
```
